#!/usr/bin/perl
# Convert TRMG.txt to a fortune source file
# 2000-11-15 unslider

use IPC::Open2;

# Find the beginning of the rhymes
1 while(<>!~/^You shall have an apple/);
for(1..8) { <> }; # this should put us at the "LITTLE BO-PEEP" line

# Now go through the rest of the file, pick out each rhyme, and process it
for(;;) {
	chomp($line=<>);
	$line=~s/\x0d//; # grr, msdos is alive in 2000?
	$alpha=$line;
	$alpha=~s/[^A-Za-z]//g;
	if($alpha=~/^[A-Z]+$/) {
		# Found the start of a new rhyme, so do the voodoo with the
		# old one
		pop(@rhyme) if($line=~/^END OF THE /); # drop .:*~ crap
		spit(@rhyme) if defined(@rhyme);
		exit if($line=~/^END OF THE /);
		undef @rhyme;
	}
	push @rhyme, $line;
}

# format and print one rhyme
sub spit {
	my(@rhyme)=@_;
	my($text,$title);

	# some of the rhymes are problematic to format and need to be done
	# manually; skip these.
	return if(grep {$rhyme[0]=~/$_/} qw(HUBBARD HOUSE THUMBKIN BRIDGE
	          BURIAL));

	# drop trailing blank lines
	pop(@rhyme) while(scalar(@rhyme)>0 && $rhyme[$#rhyme]=~/^\s*$/);

	$|=1; # perl BUG workaround for duplicate output with open2
	if(scalar(@rhyme)>19) {
		# excessively long rhymes need to be reformatted
		$title=shift(@rhyme);
		shift(@rhyme); # title is followed by a blank line
		$text=join("\n",@rhyme);
		$text=~s/^$/BLANKLINE/gm;
		$text=pipethru('column',$text);
		$text=~s/BLANKLINE/         /g;
		$text=~s/\n+$//;
		if(scalar(split(/\n/,$text))>21) { # XXX count with y///
			# sigh. still too big. need to take serious measures.
			$text=pipethru('fmt',join(" /\n",@rhyme));
			$text=~s, /$,,gm;
			$text=~s,^/ ,,gm;
		}
		$text=" - $title -\n$text";
	} else {
		$text=join("\n",@rhyme);
	}

	print "$text\n -- The Real Mother Goose\n%\n";
}

# given a text string, pipe it through a program
sub pipethru {
	my($program,$text)=@_;

	open2(\*RDR,\*WTR,$program);
	print WTR "$text\n";
	close WTR;
	$text=join('',<RDR>);
	close RDR;
	return $text;
}
